PROGRAM RADIOSOUND
!
! We take the whole flight (go and back) and we plot both on the same picture
!

IMPLICIT NONE

!**************************************
CHARACTER(2)          :: DAY,MONTH,YEAR
CHARACTER(4)          :: HOUR
CHARACTER(100)        :: FILEIN,DATE,PUBELLE
CHARACTER(100)        :: FILEOUT
INTEGER               :: I,IERR,NbLines
REAL                  :: xmin,xmax,xhmin,xhmax
REAL                  :: maxTEMP,maxTEMPD,maxRH,maxMR,maxPRES,maxAZ,maxWDIR,maxWMOD,maxALT
REAL                  :: minTEMP,minTEMPD,minRH,minMR,minPRES,minAZ,minWDIR,minWMOD,minALT
REAL,DIMENSION(:),ALLOCATABLE    :: TEMP,PRES,RH,U_NORTH,U_EAST,ALT,PSCL,TEMPD,MR,WDIR,WMOD
REAL,DIMENSION(:),ALLOCATABLE    :: TIME,AZ,RANG,LON,LAT,SPUKEY,USRKEY,RADARH

!**************************************

PRINT *, 'Reading name of file: '
READ(5,*) FILEIN
PRINT*,FILEIN
PRINT *, 'Reading of day: '
READ(5,*) DATE
PRINT*, DATE

NbLines=0
OPEN(UNIT=99,FILE=FILEIN,FORM='FORMATTED',IOSTAT=IERR,STATUS='OLD',ACCESS='SEQUENTIAL')
DO WHILE (IERR==0)
 READ(99,*, IOSTAT=IERR)
 IF (IERR==0) THEN
 NbLines=NbLines+1
 ENDIF
ENDDO
CLOSE(99)

PRINT*,'NbLines=',NbLines

ALLOCATE(TIME(NbLines))
ALLOCATE(TEMP(NbLines))
ALLOCATE(PRES(NbLines))
ALLOCATE(RH(NbLines))
ALLOCATE(U_NORTH(NbLines))
ALLOCATE(U_EAST(NbLines))
ALLOCATE(ALT(NbLines))
ALLOCATE(PSCL(NbLines))
ALLOCATE(TEMPD(NbLines))
ALLOCATE(MR(NbLines))
ALLOCATE(WDIR(NbLines))
ALLOCATE(WMOD(NbLines))
ALLOCATE(AZ(NbLines))
ALLOCATE(RANG(NbLines))
ALLOCATE(LON(NbLines))
ALLOCATE(LAT(NbLines))
ALLOCATE(SPUKEY(NbLines))
ALLOCATE(USRKEY(NbLines))
ALLOCATE(RADARH(NbLines))

OPEN(UNIT=99,FILE=FILEIN,FORM='FORMATTED',STATUS='OLD',ACCESS='SEQUENTIAL')
DO I=1,NbLines
READ(99,*) TIME(I),PSCL(I),TEMP(I),RH(I),U_NORTH(I),U_EAST(I),ALT(I),PRES(I),TEMPD(I),MR(I),WDIR(I),WMOD(I), &
           AZ(I),RANG(I),LON(I),LAT(I),SPUKEY(I),USRKEY(I),RADARH(I)
!ALT(I)=ALT(I)*1E-3
!PRINT*, TIME(I),PSCL(I),TEMP(I),RH(I),U_NORTH(I),U_EAST(I),ALT(I),PRES(I),TEMPD(I),MR(I),WDIR(I),WMOD(I), &
!           AZ(I),RANG(I),LON(I),LAT(I),SPUKEY(I),USRKEY(I),RADARH(I)
ENDDO
CLOSE(99)


maxTEMP=MAXVAL(TEMP)
PRINT*, 'maxTEMP=',maxTEMP
maxRH=MAXVAL(RH)
PRINT*, 'maxRH=',maxRH
maxPRES=MAXVAL(PRES)
PRINT*, 'maxPRES=',maxPRES
maxTEMPD=MAXVAL(TEMPD)
PRINT*, 'maxTEMPD=',maxTEMPD
maxMR=MAXVAL(MR)
PRINT*, 'maxMR=',maxMR
maxWDIR=MAXVAL(WDIR)
PRINT*, 'maxWDIR=',maxWDIR
maxWMOD=MAXVAL(WMOD)
PRINT*, 'maxWMOD=',maxWMOD
maxAZ=MAXVAL(AZ)
PRINT*, 'maxAZ=',maxAZ
maxALT=MAXVAL(ALT)
PRINT*, 'maxALT=',maxALT
!******************************************
minTEMP=MINVAL(TEMP)
PRINT*, 'minTEMP=',minTEMP
minRH=MINVAL(RH)
PRINT*, 'minTEMP=',minTEMP
PRINT*, 'minRH=',minRH
minPRES=MINVAL(PRES)
PRINT*, 'minPRES=',minPRES
minTEMPD=MINVAL(TEMPD)
PRINT*, 'minTEMPD=',minTEMPD
minMR=MINVAL(MR)
PRINT*, 'minMR=',minMR
minWDIR=MINVAL(WDIR)
PRINT*, 'minWDIR=',minWDIR
minWMOD=MINVAL(WMOD)
PRINT*, 'minWMOD=',minWMOD
minAZ=MINVAL(AZ)
PRINT*, 'minAZ=',minAZ
minALT=MINVAL(ALT)
PRINT*, 'maxALT=',maxALT
! GRAPHIC
!******************************************
!
! First plot: 0-22km
!
xmin=180.
xmax=300.
xhmin=0
xhmax=24000.

CALL PGBEGIN(0,'?',2,2)
CALL PGSCH(1.2)
CALL PGENV(xmin,xmax,xhmin,xhmax,0,1)
CALL PGLABEL('Temp. (K)','Height (m)',DATE)
!DO I=1,NbLines
!IF(TEMP(I).NE.-32768.)THEN
!CALL PGPT(1,TEMP(I),ALT(I),3)
!ENDIF
!ENDDO
DO I=1,NbLines-1
IF( (TEMP(I).NE.-32768.) .AND. (TEMP(I+1).NE.-32768.) )THEN
CALL PGLINE(2,TEMP(I),ALT(I))
ENDIF
ENDDO
!
CALL PGEND
END PROGRAM
